<?php
require_once('config.php');
require_once('utilities.php');
require_once('facebook_app.php');
require_once('vb_api_client.php');
require_once('user_info.php');
FacebookApp::instance()->ensureFacebookUserLoggedInToVB();

final class Forums {    
    // + Singleton implementation
    private static $instance = null;
    public static function instance() {
        if(!isset(self::$instance)) {
            self::$instance = new Forums();
        }
        return self::$instance;
    }
	private function __construct() {
        $this->json = json_decode(VBApiClient::instance()->call_cached_session('api_forumlist', array(), array(), $this->cache_for), true);
		ForumInfo::populateForums($this->json);
	}
    // - Singleton implementation
    
    private $json;
    private $cache_for = 20;
    public function renderForums() {
        ob_start();
        foreach($this->json as $forum) {    ?>
            <div class="category_box">
            <div class="wrapper">          
            <table class="list">
                <tr class="first">
                    <td class="one">
<?php       if($forum['is_category'] == 1) {    ?>
                        <?php echo $forum['title_clean']; ?>
<?php       }   ?>
                    </td>
<?php       if($forum['is_link'] == 0) {    ?>
                    <td class="two">Topics</td>
                    <td class="three">Posts</td>
                    <td class="four">Last post</td>
<?php       } else {  ?>
                    <td class="two"></td>
                    <td class="three"></td>
                    <td class="four"></td>
<?php       }   ?>                    
                </tr>
<?php       if($forum['is_category'] == 1 && !empty($forum['subforums'])) {
                foreach($forum['subforums'] as $subforum) {
                    $this->renderForum($subforum);
                }
            } else {
                $this->renderForum($forum);
            }   ?>               
            </table>
            <div class="category_shadow">
                <div class="category_shadow_left"></div>
                <div class="category_shadow_center"></div>
                <div class="category_shadow_right"></div>
            </div>
            </div>
            </div>
            
<?php   }   ?>
        <div class="clear"></div>
<?php
        $out = ob_get_contents();
        ob_end_clean();
        echo $out;
        return time() + $this->cache_for;
    }
    
    private function renderForum($forum) {
        ob_start();
?>
        <tr>
            <td class="one">
                <a class="title" href="<?php echo $this->getForumLink($forum); ?>"><?php echo $forum['title_clean']; ?></a>
                <br/>
<?php   if(!empty($forum['description'])) { ?>
                <div class="description">
<?php           echo $forum['description']; ?>
                </div>
<?php   }
        if($forum['is_link'] != 1) {
        if(isset($forum['subforums'])) {    ?>            
                <div class="subforums">Sub-Forums:
<?php
            foreach($forum['subforums'] as $subforum) { ?>
                    <a class="smalllink" href="<?php echo $this->getForumLink($subforum); ?>"><?php echo $subforum['title_clean']; ?></a>
<?php       }   ?>
                </div>
<?php   }   ?>
            
            </td>
            <td class="two"><div><?php echo $forum['threadcount']; ?></div></td>
            <td class="three"><div><?php echo $forum['replycount']; ?></div></td>
<?php   if(isset($forum['lastpostinfo'])) { ?>
            <td class="four">
                <?php echo timedisplay($forum['lastpostinfo']['lastposttime']); ?><br/>
<?php   
        $user_info = UserInfo::get($forum['lastpostinfo']['lastposter']);
        $user_info->setVBUserid($forum['lastpostinfo']['lastposterid']);
        UserInfo::set($user_info);
?>
                by <a class="smalllink" href="<?php echo $user_info->getProfileUrl(); ?>"><?php echo $forum['lastpostinfo']['lastposter']; ?></a>
            </td>
<?php   }} else {   ?>
            </td><td/><td/><td/>
<?php   }   ?>
        </tr>
<?php
        $out = ob_get_contents();
        ob_end_clean();
        echo $out;
    }
    
    private function getForumLink($forum) {
        if($forum['is_link'] == 1) {
            return $forum['link'];
        }
        else return 'category_stream.php?category=Forum_Threads_'.$forum['forumid'];
    }
}

display_header();
?>
<div id="dbcontent">
    <div id="box_view" class="content">
    <div class="forumname"><?php echo FACEBOOK_APP_NAME; ?> </div>   
    <?php $timestamp = Forums::instance()->renderForums(); ?>   
    </div>
</div>
<?php 
display_footer($timestamp); 
?>
